<?php 
/**
 * Suspension Page Controller
 * @category  Controller
 */
class SuspensionController extends SecureController{
	function __construct(){
		parent::__construct();
		$this->tablename = "suspension";
	}
	/**
     * List page records
     * @param $fieldname (filter record by a field) 
     * @param $fieldvalue (filter field value)
     * @return BaseView
     */
	function index($fieldname = null , $fieldvalue = null){
		$request = $this->request;
		$db = $this->GetModel();
		$tablename = $this->tablename;
		$fields = array("suspension.id", 
			"employee_details.employee_name AS employee_details_employee_name", 
			"suspension.date_of_suspension", 
			"suspension.suspension_type");
		$pagination = $this->get_pagination(MAX_RECORD_COUNT); // get current pagination e.g array(page_number, page_limit)
		//search table record
		if(!empty($request->search)){
			$text = trim($request->search); 
			$search_condition = "(
				suspension.id LIKE ? OR 
				suspension.empid LIKE ? OR 
				employee_details.employee_name LIKE ? OR 
				suspension.date_of_suspension LIKE ? OR 
				suspension.total_salary_deducted LIKE ? OR 
				suspension.has_added LIKE ? OR 
				employee_details.id LIKE ? OR 
				employee_details.portfolio_id LIKE ? OR 
				employee_details.basic_pay LIKE ? OR 
				employee_details.bank_acc_no LIKE ? OR 
				employee_details.bank_name LIKE ? OR 
				employee_details.email LIKE ? OR 
				employee_details.dob LIKE ? OR 
				employee_details.date_of_join LIKE ? OR 
				employee_details.date_of_retirement LIKE ? OR 
				employee_details.department LIKE ? OR 
				suspension.suspension_type LIKE ?
			)";
			$search_params = array(
				"%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%","%$text%"
			);
			//setting search conditions
			$db->where($search_condition, $search_params);
			 //template to use when ajax search
			$this->view->search_template = "suspension/search.php";
		}
		$db->join("employee_details", "suspension.empid = employee_details.id", "INNER");
		if(!empty($request->orderby)){
			$orderby = $request->orderby;
			$ordertype = (!empty($request->ordertype) ? $request->ordertype : ORDER_TYPE);
			$db->orderBy($orderby, $ordertype);
		}
		else{
			$db->orderBy("suspension.id", ORDER_TYPE);
		}
		if($fieldname){
			$db->where($fieldname , $fieldvalue); //filter by a single field name
		}
		$tc = $db->withTotalCount();
		$records = $db->get($tablename, $pagination, $fields);
		$records_count = count($records);
		$total_records = intval($tc->totalCount);
		$page_limit = $pagination[1];
		$total_pages = ceil($total_records / $page_limit);
		$data = new stdClass;
		$data->records = $records;
		$data->record_count = $records_count;
		$data->total_records = $total_records;
		$data->total_page = $total_pages;
		if($db->getLastError()){
			$this->set_page_error();
		}
		$page_title = $this->view->page_title = "Suspension";
		$this->view->report_filename = date('Y-m-d') . '-' . $page_title;
		$this->view->report_title = $page_title;
		$this->view->report_layout = "report_layout.php";
		$this->view->report_paper_size = "A4";
		$this->view->report_orientation = "portrait";
		$this->render_view("suspension/list.php", $data); //render the full page
	}
	/**
     * View record detail 
	 * @param $rec_id (select record by table primary key) 
     * @param $value value (select record by value of field name(rec_id))
     * @return BaseView
     */
	function view($rec_id = null, $value = null){
		$request = $this->request;
		$db = $this->GetModel();
		$rec_id = $this->rec_id = urldecode($rec_id);
		$tablename = $this->tablename;
		$fields = array("suspension.id", 
			"suspension.empid", 
			"suspension.date_of_suspension", 
			"suspension.total_salary_deducted", 
			"suspension.has_added", 
			"employee_details.id AS employee_details_id", 
			"employee_details.employee_name AS employee_details_employee_name", 
			"employee_details.portfolio_id AS employee_details_portfolio_id", 
			"employee_details.basic_pay AS employee_details_basic_pay", 
			"employee_details.bank_acc_no AS employee_details_bank_acc_no", 
			"employee_details.bank_name AS employee_details_bank_name", 
			"employee_details.email AS employee_details_email", 
			"employee_details.dob AS employee_details_dob", 
			"employee_details.date_of_join AS employee_details_date_of_join", 
			"employee_details.date_of_retirement AS employee_details_date_of_retirement", 
			"employee_details.department AS employee_details_department", 
			"suspension.suspension_type");
		if($value){
			$db->where($rec_id, urldecode($value)); //select record based on field name
		}
		else{
			$db->where("suspension.id", $rec_id);; //select record based on primary key
		}
		$db->join("employee_details", "suspension.empid = employee_details.id", "INNER ");  
		$record = $db->getOne($tablename, $fields );
		if($record){
			$page_title = $this->view->page_title = "View  Suspension";
		$this->view->report_filename = date('Y-m-d') . '-' . $page_title;
		$this->view->report_title = $page_title;
		$this->view->report_layout = "report_layout.php";
		$this->view->report_paper_size = "A4";
		$this->view->report_orientation = "portrait";
		}
		else{
			if($db->getLastError()){
				$this->set_page_error();
			}
			else{
				$this->set_page_error("No record found");
			}
		}
		return $this->render_view("suspension/view.php", $record);
	}
	/**
     * Insert new record to the database table
	 * @param $formdata array() from $_POST
     * @return BaseView
     */
	function add($formdata = null){
		if($formdata){
			$db = $this->GetModel();
			$tablename = $this->tablename;
			$request = $this->request;
			//fillable fields
			$fields = $this->fields = array("empid","date_of_suspension","suspension_type");
			$postdata = $this->format_request_data($formdata);
			$this->rules_array = array(
				'empid' => 'required',
				'date_of_suspension' => 'required',
				'suspension_type' => 'required',
			);
			$this->sanitize_array = array(
				'empid' => 'sanitize_string',
				'date_of_suspension' => 'sanitize_string',
				'suspension_type' => 'sanitize_string',
			);
			$this->filter_vals = true; //set whether to remove empty fields
			$modeldata = $this->modeldata = $this->validate_form($postdata);
			if($this->validated()){
				$rec_id = $this->rec_id = $db->insert($tablename, $modeldata);
				if($rec_id){
					$this->set_flash_msg("Record added successfully", "success");
					return	$this->redirect("suspension");
				}
				else{
					$this->set_page_error();
				}
			}
		}
		$page_title = $this->view->page_title = "Add New Suspension";
		$this->render_view("suspension/add.php");
	}
	/**
     * Update table record with formdata
	 * @param $rec_id (select record by table primary key)
	 * @param $formdata array() from $_POST
     * @return array
     */
	function edit($rec_id = null, $formdata = null){
		$request = $this->request;
		$db = $this->GetModel();
		$this->rec_id = $rec_id;
		$tablename = $this->tablename;
		 //editable fields
		$fields = $this->fields = array("id","empid","date_of_suspension","suspension_type");
		if($formdata){
			$postdata = $this->format_request_data($formdata);
			$this->rules_array = array(
				'empid' => 'required',
				'date_of_suspension' => 'required',
				'suspension_type' => 'required',
			);
			$this->sanitize_array = array(
				'empid' => 'sanitize_string',
				'date_of_suspension' => 'sanitize_string',
				'suspension_type' => 'sanitize_string',
			);
			$modeldata = $this->modeldata = $this->validate_form($postdata);
			if($this->validated()){
				$db->where("suspension.id", $rec_id);;
				$bool = $db->update($tablename, $modeldata);
				$numRows = $db->getRowCount(); //number of affected rows. 0 = no record field updated
				if($bool && $numRows){
					$this->set_flash_msg("Record updated successfully", "success");
					return $this->redirect("suspension");
				}
				else{
					if($db->getLastError()){
						$this->set_page_error();
					}
					elseif(!$numRows){
						//not an error, but no record was updated
						$page_error = "No record updated";
						$this->set_page_error($page_error);
						$this->set_flash_msg($page_error, "warning");
						return	$this->redirect("suspension");
					}
				}
			}
		}
		$db->where("suspension.id", $rec_id);;
		$data = $db->getOne($tablename, $fields);
		$page_title = $this->view->page_title = "Edit  Suspension";
		if(!$data){
			$this->set_page_error();
		}
		return $this->render_view("suspension/edit.php", $data);
	}
	/**
     * Delete record from the database
	 * Support multi delete by separating record id by comma.
     * @return BaseView
     */
	function delete($rec_id = null){
		Csrf::cross_check();
		$request = $this->request;
		$db = $this->GetModel();
		$tablename = $this->tablename;
		$this->rec_id = $rec_id;
		//form multiple delete, split record id separated by comma into array
		$arr_rec_id = array_map('trim', explode(",", $rec_id));
		$db->where("suspension.id", $arr_rec_id, "in");
		$bool = $db->delete($tablename);
		if($bool){
			$this->set_flash_msg("Record deleted successfully", "success");
		}
		elseif($db->getLastError()){
			$page_error = $db->getLastError();
			$this->set_flash_msg($page_error, "danger");
		}
		return	$this->redirect("suspension");
	}
}
